/*
 Copyright (C) 2007 Christian Dywan <christian@twotoasts.de>

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef __WEBSEARCH_H__
#define __WEBSEARCH_H__ 1

#include "ui.h"
#include "helpers.h"
#include "debug.h"

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <libsexy/sexy-icon-entry.h>

// -- Types

typedef struct
{
    CBrowser* browser;
    GtkWidget* window;
    GtkWidget* treeview;
    GtkWidget* edit;
    GtkWidget* remove;
} CWebSearch;

enum
{
    ENGINES_COL_INDEX,
    ENGINES_COL_ICON,
    ENGINES_COL_NAME,
    ENGINES_COL_DESCRIPTION,
    ENGINES_COL_N
};

// -- Declarations

void update_searchEngine(guint, CBrowser*);

void on_webSearch_icon_released(GtkWidget*, SexyIconEntryPosition*, gint, CBrowser*);

void on_webSearch_engine_activate(GtkWidget*, CBrowser*);

void on_webSearch_activate(GtkWidget*, CBrowser*);

GtkWidget* webSearch_manageSearchEngines_dialog_new(CBrowser*);

gboolean on_webSearch_key_down(GtkWidget*, GdkEventKey*, CBrowser*);

gboolean on_webSearch_scroll(GtkWidget*, GdkEventScroll*, CBrowser*);

#endif /* !__WEBSEARCH_H__ */
