/*
 Copyright (C) 2007 Christian Dywan <christian@twotoasts.de>

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef __webView_H__
#define __webView_H__ 1

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include "ui.h"
#include "browser.h"
#include "helpers.h"
#include "sokoke.h"
#include "debug.h"

#include <webkitwebview.h>
#include <webkitwebframe.h>
#include <webkitnetworkrequest.h>
#include <webkitglobal.h>

WebKitNavigationResponse on_webView_navigation_requested(GtkWidget* webView
 , WebKitWebFrame* frame, WebKitNetworkRequest* networkRequest);

void on_webView_location_changed(GtkWidget*, const gchar*, CBrowser*);

void on_webView_title_changed(GtkWidget*, const gchar*, const gchar*, CBrowser*);

// void on_frame_title_changed(WebKitWebFrame*, const gchar*, const gchar*, CBrowser*);

void on_webView_icon_changed(GtkWidget*, WebKitWebFrame*, CBrowser*);

void on_webView_load_started(GtkWidget* , WebKitWebFrame*, CBrowser*);

void on_webView_load_changed(GtkWidget*, gint progress, CBrowser*);

void on_webView_load_finished(GtkWidget*, WebKitWebFrame*, CBrowser*);

// void on_frame_cleared(WebKitWebFrame*, CBrowser*);

// void on_frame_load_done(WebKitWebFrame*, gboolean, CBrowser*);

void on_webView_status_message(GtkWidget*, const gchar*, CBrowser*);

void on_webView_selection_changed(GtkWidget*, CBrowser*);

gboolean on_webView_console_message(GtkWidget*, const gchar*
 , gint, const gchar*, CBrowser*);

// void on_webView_request_auth_prompt(GtkWidget*, CBrowser*);

// gboolean on_webView_set_cookie(GtkWidget*, CBrowser*);

void on_webView_link_hover(GtkWidget*, const gchar*, const gchar*, CBrowser*);

GtkWidget* on_webView_window_open(GtkWidget*, const gchar*, CBrowser*);

// void on_webView_window_features(GtkWidget*, CBrowser*);

gboolean on_webView_button_release(GtkWidget*, GdkEventButton*, CBrowser*);

void on_webView_popup(GtkWidget*, CBrowser*);

gboolean on_webView_scroll(GtkWidget*, GdkEventScroll*, CBrowser*);

gboolean on_webView_leave(GtkWidget*, GdkEventCrossing*, CBrowser*);

void on_webView_destroy(GtkWidget*, CBrowser*);

GtkWidget* webView_new(GtkWidget**);

void webView_open(GtkWidget*, const gchar*);

void webView_close(GtkWidget*, CBrowser*);

#endif /* !__webView_H__ */
